package com.edunetcracker.simulator.service;

import com.edunetcracker.simulator.database.repository.networkElementRepository.SwitchRepository;
import com.edunetcracker.simulator.model.Scene;
import com.edunetcracker.simulator.model.element.switchNE.Switch;
import com.edunetcracker.simulator.model.port.SwitchPort;
import com.edunetcracker.simulator.service.configurers.SwitchConfigurer;
import com.edunetcracker.simulator.service.context.ContextService;
import com.edunetcracker.simulator.service.status.SequenceStatus;
import lombok.Getter;
import lombok.Synchronized;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

@Service
public class SwitchService extends DBService<Switch> {
    private static Logger logger = LoggerFactory.getLogger(SwitchService.class);

    @Autowired
    private SwitchRepository switchRepository;

    @Autowired
    private SwitchConfigurer switchConfigurer;
    @Autowired
    private ContextService contextService;
    @Autowired
    private PortService portService;
    @Autowired
    private LinkService linkService;

    @Getter
    private List<Switch> loadedSwitches = new ArrayList<>();

    @Override
    public Switch getLoaded(long id) {
        for (Switch switchEl : loadedSwitches) {
            if (switchEl.getIdNE() == id) {
                return switchEl;
            }
        }
        return null;
    }

    /**
     * "DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE |
     * "DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE |
     * "DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE |
     * @param id ID of a Port to seek
     * @return MAY RETURN AN INSTANCE WITHOUT AN OWNER
     */
    @Deprecated
    @Override
    public Switch get(long id) {
        logger.error("DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE | ");
        logger.error("DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE | ");
        logger.error("DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE | ");

        Switch loadedSwitch = getLoaded(id);
        if (null != loadedSwitch) {
            return loadedSwitch;
        }
        Optional<Switch> newlyLoaded = switchRepository.findByIdNE(id);
        if (!newlyLoaded.isPresent()) {
            SequenceStatus.NOT_FOUND_IN_DATABASE.logWarning("Switch", id);
            return null;
        }
        trackRecursively(newlyLoaded.get());
        return newlyLoaded.get();
    }

    @Override
    public SequenceStatus create(Switch switchEl) {
        if (null == switchEl) {
            SequenceStatus.NULL_POINTER.logError("saveSwitch", "switchEl");
            throw new NullPointerException();
        }
        long instanceId = switchEl.getIdNE();
        if (instanceId != 0) {
            SequenceStatus.UNEXPECTED_FIELD_VALUE.logError("0", "idNE", "switchEl");
            throw new IllegalArgumentException();
        }

        Scene scene = SceneService.getInstance().getLoaded(switchEl.getSceneId());
        if (null == scene) {
            SequenceStatus.UNTRACKED_DB_OBJECT.logError("Scene");
            throw new ArrayStoreException();
        }
        switchEl.setScene(scene);
        scene.addNetworkElement(switchEl);

        switchConfigurer.givePortsTo(switchEl);
        trackRecursively(switchEl);
        update(switchEl);

        return SequenceStatus.OK;
    }

    @Override
    public Switch update(Switch switchEl) {
        if (null == switchEl) {
            SequenceStatus.NULL_POINTER.logError("updateInDB", "switchEl");
            throw new NullPointerException();
        }
        if (null == getLoaded(switchEl.getIdNE())) {
            SequenceStatus.UNTRACKED_DB_OBJECT.logError("Switch");
            trackRecursively(switchEl);
        }
        Switch savedSwitch = switchRepository.save(switchEl);

        if (savedSwitch != switchEl) {
            switchEl.copyAutogeneratedValues(savedSwitch);
        }
        return switchEl;
    }

    @Override
    public void trackRecursively(Switch switchEl) {
        if (null == switchEl) {
            SequenceStatus.NULL_POINTER.logError("loadRecursively", "instance");
            throw new NullPointerException();
        }
        if (loadedSwitches.contains(switchEl)) {
            return;
        }

        List<SwitchPort> switchPorts = switchEl.getPorts();
        for (SwitchPort switchPort : switchPorts) {
            portService.trackRecursively(switchPort);
        }
        loadedSwitches.add(switchEl);
    }

    @Override
    public void untrackRecursively(Switch instance) {
        if (null == instance) {
            SequenceStatus.NULL_POINTER.logError("unload", "instance");
            throw new NullPointerException();
        }
        if (!loadedSwitches.contains(instance)) {
            SequenceStatus.UNTRACKED_DB_OBJECT.logError("SwitchService");
            return;
        }

        List<SwitchPort> switchPorts = instance.getPorts();
        for (SwitchPort switchPort : switchPorts) {
            portService.untrackRecursively(switchPort);
        }
        loadedSwitches.remove(instance);
    }

    @Synchronized
    public SequenceStatus stop (Long switchId) {
        Switch switchNE = getLoaded(switchId);
        if (null == switchNE) {
            return SequenceStatus.UNTRACKED_DB_OBJECT;
        }
        switchNE.setWorking(false);
        List<Long> linkIds =
                switchNE.getPorts().stream()
                        .filter(switchPort -> null != switchPort.getConnection())
                        .map(switchPort -> switchPort.getConnection().getLink().getId())
                        .collect(Collectors.toList());
        Scene scene = switchNE.getScene();

        scene.getNetworkElements().remove(switchNE);
        untrackRecursively(switchNE);

        Optional<Switch> switchOpt = switchRepository.findByIdNE(switchId);
        if (switchOpt.isPresent())
            switchNE = switchOpt.get();
        scene.getNetworkElements().add(switchNE);
        trackRecursively(switchNE);

        for (Long linkId : linkIds) {
            linkService.linkComps(linkId);
        }

        return SequenceStatus.OK;
    }

    @Override
    public void drop(Switch instance) {
        if (null == instance) {
            SequenceStatus.NULL_POINTER.logError("dropFromDB", "instance");
            throw new NullPointerException();
        }
        switchRepository.delete(instance);
    }

    public SequenceStatus delete(Long id) {
        throw new NotImplementedException();
    }

    @Override
    public SequenceStatus delete(Switch instance) {
        throw new NotImplementedException();
    }
}
